<?php

namespace Drupal\edlp_ajax_node\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\JsonResponse;


class EdlpAjaxNodeController extends ControllerBase {

  private function query() {
    $this->node = entity_load('node', $this->nid);
  }

  private function toRenderable(){
    $this->query();

    if($this->node){
      return array(
        "#theme"=>'edlp_ajax_node',
        '#node_object' => $this->node,
        '#view_mode' => $this->viewmode,
      );
    }else{
      return array(
        '#markup'=>'404! Node '.$this->nid." not found!"
      );
    }
  }

  /**
   * Display node as a page.
   *
   * @return renderable array
   */
  public function node($nid, $viewmode) {
    $this->nid = $nid;
    $this->viewmode = $viewmode;
    return $this->toRenderable();
  }

  /**
   * Get node as json through ajax.
   *
   * @return json
   */
  public function nodejson($nid, $viewmode) {
    $this->nid = $nid;
    $this->viewmode = $viewmode;
    $renderable = $this->toRenderable();
    $rendered = render($renderable);

    $response = new JsonResponse();
    $response->setData([
      'test' => 'hello edlp ajax node',
      'nid' => $this->nid,
      'view_mode' => $this->viewmode,
      'rendered'=> $rendered,
    ]);

    return $response;
  }

}
